SoDirectionalLight(3)

NAME
SoDirectionalLight - The SoDirectionalLight class is a node type for specifying directional light sources.

SYNOPSIS

#include <Inventor/nodes/SoDirectionalLight.h>

Inherits SoLight.

Inherited by SoDirectionalLightManip, and SoShadowDirectionalLight.

  Public Member Functions
virtual SoType getTypeId (void) const
SoDirectionalLight (void)
virtual void GLRender (SoGLRenderAction *action)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.

  Public Attributes
SoSFVec3f direction

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoDirectionalLight ()

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoDirectionalLight class is a node type for specifying directional light sources. A directional light source provides a model of light sources which are at infinite distance from the geometry it illuminates, thereby having no set position and consisting of an infinite volume of parallel rays.

This is of course a simplified model of far-away light sources, as 'infinite distance' is impossible.

The sun shining on objects on earth is a good example of something which can be modeled rather well for the most common purposes with a directional light source.

See also documentation of parent class for important information regarding light sources in general.

FILE FORMAT/DEFAULTS:

DirectionalLight {
    on TRUE
    intensity 1
    color 1 1 1
    direction 0 0 -1
}

A common thing to do with an SoDirectionalLight is to connect it to a camera, so it works in the style of a head light to that camera. This can easily be accomplished by linking an SoRotation::rotation field, influencing the light, to the SoCamera::orientation field. Here is a complete example iv-file demonstrating the technique:

#Inventor V2.1 ascii
DEF mycam PerspectiveCamera { }
TransformSeparator {
   SoRotation { rotation = USE mycam.orientation }
   DirectionalLight { direction 0 0 -1 }
}
Cube { }

(The SoTransformSeparator is included to keep the effect of the SoRotation node within a scope where it will only influence the light, and not the geometry following the light in the scene graph.)

Constructor & Destructor Documentation

  SoDirectionalLight::SoDirectionalLight (void)
Constructor.

  SoDirectionalLight::~SoDirectionalLight () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoDirectionalLight::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoDirectionalLight::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoLight.

Reimplemented in SoShadowDirectionalLight, and SoDirectionalLightManip.

  const SoFieldData ** SoDirectionalLight::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoDirectionalLight::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoLight.

Reimplemented in SoShadowDirectionalLight, and SoDirectionalLightManip.

  void SoDirectionalLight::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

Reimplemented in SoShadowDirectionalLight, and SoDirectionalLightManip.

Member Data Documentation

  SoSFVec3f SoDirectionalLight::direction
The direction of the light source. Defaults to pointing along the negative Z-axis.

Author

Generated automatically by Doxygen for Coin from the source code.